package de.uni_muenster.tools;

import java.io.BufferedWriter;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.OutputStream;
import java.util.Vector;
import java.util.zip.GZIPOutputStream;


public class LogWriter extends Thread
{
    private Vector logEntrys = new Vector(100);
    private MaskedStreamWriter maskedWriter;
    private BufferedWriter statsWriter;
    private boolean end = false;
    private int phase = 0;
    //doesn't work till now...
    private static final boolean compress = true;

    public LogWriter(String reportDir, String fileName)
    {
        super("LogWriter");
        try
        {
            OutputStream out;
            if (compress)
            {
                out = new GZIPOutputStream(new FileOutputStream(reportDir + fileName + ".gz"));
            } else
            {
                out = new FileOutputStream(reportDir + fileName);
            }
            maskedWriter = new MaskedStreamWriter(out, MaskedStreamWriter.ASCII_MASK);
            statsWriter = new BufferedWriter(maskedWriter, 32 * 1024);
            this.setPriority(Thread.MIN_PRIORITY);
        } catch (Exception e)
        {
            throw new RuntimeException("!!!Error creating LogWriter!!!");
        }
    }

    public void addLog(String logEntry)
    {
        logEntrys.add(logEntry);
    }

    public void run()
    {
        int retry = 0;
        do
        {
            do
            {
                try
                {
                    //wait till some stats has arrived
                    sleep(2000);
                    if (!logEntrys.isEmpty())
                    {
                        while (!logEntrys.isEmpty())
                        {
                            statsWriter.write((String) logEntrys.remove(0));
                        }
                        statsWriter.flush();
                        retry = 0;
                    }
                } catch (Exception e)
                {
                    System.out.println("!!! Error flushing logEntrys !!!");
                    retry++;
                    if (retry > 5) throw new RuntimeException("Cannot flush logentrys while 5 tries.");
                }
            } while (!end);
        }
                //in case some stats arrived after main clients sets end...
        while (!logEntrys.isEmpty());
        System.out.println("Trying to close statsWriter...");
        try
        {
            statsWriter.close();
        } catch (IOException e)
        {
            System.out.println("Error occured during closing statsWriter...");
            e.printStackTrace();
        }
        System.out.println("LogWriter leaving....");

    }

    public void end()
    {
        addLog("All logs done!!!");
        this.end = true;
    }

}
