/*

Copyright (c) 2003 Remigius Kuzyna <kuzyna@gmx.de>.

LGPL
====

This is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This software is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

For LGPL see <http://www.fsf.org/copyleft/lesser.txt>

*/

package de.uni_muenster.tools;

import java.net.MalformedURLException;
import java.net.URL;

/**
 */
public class PostURL
{
    private URL url;
    private String parameters;

    public PostURL(String protocol, String host, int port, String file, String param) throws MalformedURLException
    {
        url = new URL(protocol, host, port, file);
        parameters = param;
    }

    public PostURL(String protocol, String host, int port, String file) throws MalformedURLException
    {
        url = new URL(protocol, host, port, file);
        parameters = null;
    }

    public URL getUrl()
    {
        return url;
    }

    public void setUrl(URL url)
    {
        this.url = url;
    }

    public String getParameters()
    {
        return parameters;
    }

    public void setParameters(String parameters)
    {
        this.parameters = parameters;
    }

    public String toString()
    {
        return url.toString() + parameters;
    }
}
